// Section 1: Preprocessor Directives, External & Internal Variables

#property copyright "Copyright  2012, Steven Randolf (ForexRazor.com)" 
#property link "http://www.forexrazor.com/" 

#import "Kernel32.dll"
   void GetSystemTime(int& a0[]);

extern string  BuyComment = "MACD-Buy";              
extern string  SellComment = "MACD-Sell";
extern bool    BuyOnly = false; 
extern bool    SellOnly = false; 
extern bool    reverse = false; 
extern string  MACDStrategy = "1: Main crosses zero line, 2: Main crosses Signal"; 
extern int     strategy = 1; 
extern string  CurrencySymbol = "0: Chart symbol; 1, EURUSD, 2: GBPUSD, 3: AUDUSD"; 
extern int     symbol = 0; 
extern double  MagicNumber = 125675; 
extern string _1 = "+----- Entry Settings -----+";
extern bool    MACDAlways = false; 
extern int      MACDTimeFrame       = 0;        // Time frame for MACD calculation
extern int      FastPeriod          = 12;       // MACD EMA Fast Period
extern int      SlowPeriod          = 30;       // MACD EMA Slow Period
extern int      SignalPeriod        = 9;        // MACD EMA Signal Period
extern int      MACDPrice           = 0;        // 0=close, 1=open, 2=high, 3=low, 4=HL/2, 5=HLC/3 6=HLCC/4
bool            EnterOpenBar = true; 
int             Slippage = 0; 
extern bool    ECN = true; 
extern int     MaxDayOrders = 1; 
extern string _2 = "+----- Exit Settings -----+";
extern bool    OppositeClose = true; 
extern double  StopLoss   =80;     
extern double  TakeProfit =0;
extern double  BreakEvenStart = 0; 
extern double  BreakEven = 0; 
extern double  TrailingStart = 0; 
extern double  TrailingStop= 0;
extern double  TrailingStep = 5; 
extern string _3 = "+----- Money Management (10 = 10%) -----+";
extern bool    MM = false;
extern double  Risk = 2;
extern double  MinLot = 0.01;
extern double  MaxLot = 100.0;
extern string _4 = "+---- Lots Management (If MM=False) ----+";
extern double  Lots = 0.1;
extern double  LotDigits  =2; 
extern string _5 = "+---- Alert Setting";
extern bool    EnableAlert          = true;
extern string  SoundFilename        = "alert.wav";
extern string _66 = "+----- Trading Filters -----+";

extern bool mafilter1=true;
extern bool mafilter1rev=false;
extern int matime1 = 60; 
extern int maperiod1=200;
extern int mamethod1=1;

extern bool mafilter2=false;
extern bool mafilter2rev=false;
extern int matime2 = 0; 
extern int maperiod2=50;
extern int mamethod2=1;

extern bool mafilter3=false;
extern bool mafilter3rev=false;
extern int matime3 = 0; 
extern int maperiod3=14;
extern int mamethod3=0;
extern int shift=1;                      // bar in the past to take in consideration for the signal

extern string _6 = "+----- Trading Hours -----+";
extern bool    AutoGMTOffset = TRUE;
extern double  ManualGMTOffset = 1; 
extern bool    UseTradingHours = false;
extern bool    TradeAsianMarket = false;
extern double  StartTime1 = 00.00;
extern double  EndTime1 = 01.00;
extern bool    TradeEuropeanMarket = true;
extern double  StartTime2 = 06.00;
extern double  EndTime2 = 12.00;
extern bool    TradeNewYorkMarket = true;
extern double  StartTime3 = 15.00; // 8:00 EST
extern double  EndTime3 = 24.00; 
extern string _7 = "+----- Trading Days -----+";
extern bool    Sunday = true;
extern bool    Monday = true;
extern bool    Tuesday = true;
extern bool    Wednesday = true;
extern bool    Thursday = true;
extern bool    Friday = true;
extern bool    SingleWeekDay = false; 
extern int     dayofweek = 0; 
extern bool    AvoidNFPFriday = false;
extern bool    AvoidNFPThursdayBefore = false;
extern bool    AvoidChristmasHolidays = true; 
extern double  XMAS_DayBeginBreak = 15; 
extern bool    AvoidNewYearsHolidays = false; 
extern double  NewYears_DayEndBreak = 3; 

// Internal Variables

int cnt, vSlippage;  
double ticket, number, vPoint; 
int gmtoffset;
string gs_548 = "";
int TimeFrame = 0; 

string
LastTrade,
LastAlert,
TradeDirection       = "NONE",
PreviousDirection    = "NONE",
CurrentDirection     = "NONE";
datetime                
CheckTime,
CheckEntryTime,
CrossTime,
timex;

double
BBLowCurrent,
BBLowPrevious,
BBUpCurrent,
BBUpPrevious,
BBCurrentClose,
BBPreviousClose,
FastMAPrevious,
SlowMACurrent,
SlowMAPrevious; 

double adxu,adxd,adxua,adxda;
double jma1,jma2;

string symbolname; 
int symbol1; 

datetime Time0 = 0;

// Section 2: Initialization

int init(){ 
 
if(Digits==3 || Digits==5)
{ vPoint=Point*10; vSlippage=Slippage*10; }
else{ vPoint=Point; vSlippage=Slippage; } 

return(0); } 

//--------------------------------------------------------------- 
// Section 3: Start

int start()
  {
  
//---- check for history 
if(Bars<100) { Print("Bars less than 100"); 
return(0); } 

if (symbol == 0) symbol1 = NULL;
if (symbol == 1) symbolname = "EURUSD"; 
if (symbol == 2) symbolname = "GBPUSD"; 
if (symbol == 3) symbolname = "AUDUSD"; 
if (symbol == 4) symbolname = "EURJPY"; 

if(CheckTodaysOrders() >= MaxDayOrders){

return(0); // abort

}
// Speeds up back tests
   //if (IsTesting()) ShowIndicator=FALSE;
 
 
if (!IsTesting() && AutoGMTOffset == TRUE) gmtoffset = GMTOffset();
else gmtoffset = ManualGMTOffset;

string ls_52 = "Your Strategy is Running.";
string ls_60 = "Your Strategy is set up for time zone GMT " + gmtoffset;
string ls_76 = "Account Balance= " + DoubleToStr(AccountBalance(), 2);
string ls_84 = " ";
   
 Comment("\n",
      "\n", "   ",
      "\n", "   ",      
      "\n", "   ", ls_52,
      "\n", "   ", ls_60,
      "\n", "   ", ls_76,
     // "\n", "   ", ls_77,            
      "\n");

 
              
//--------------------------------------------------------------- 
// Section 3A: Define ShortCuts to Common Functions
   
      int
   Total,                         
   OType=-1,                         
   Ticket;
      double 
   Price,
   SL,                              
   TP,                             
   Lot; 
   bool
   CloseBuy=false,                     
   CloseSell=false,                    
   OpenBuy=false,                   
   OpenSell=false;   
   
   for(int cnt=1; cnt<=OrdersTotal(); cnt++)         
     {
      if (OrderSelect(cnt-1,SELECT_BY_POS, MODE_TRADES)==true) 
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
     
        {                                            
         Ticket=OrderTicket();                  
         OType   =OrderType();                    
         Price =OrderOpenPrice();              
         SL    =OrderStopLoss();                
         TP    =OrderTakeProfit();              
         Lot   =OrderLots();                    
        }
     }
//----------------------------------------------------
// Section 3B: Get Indicators


double MACDmain=iMACD(symbolname,MACDTimeFrame,FastPeriod,SlowPeriod,SignalPeriod,MACDPrice,0,shift);
double MACDmain1=iMACD(symbolname,MACDTimeFrame,FastPeriod,SlowPeriod,SignalPeriod,MACDPrice,0,shift+1);
double MACDsignal=iMACD(symbolname,MACDTimeFrame,FastPeriod,SlowPeriod,SignalPeriod,MACDPrice,1,shift);
double MACDsignal1=iMACD(symbolname,MACDTimeFrame,FastPeriod,SlowPeriod,SignalPeriod,MACDPrice,1,shift+1);




//------------------------------------------------
// Section 3C: Entry Conditions 

bool BuyCondition1 = false; 
bool SellCondition1 = false; 
bool CloseBuyCondition1 = false; 
bool CloseSellCondition1 = false; 

bool barstatus=true; 

//---- go trading only for first ticks of new bar
//if(EnterOpenBar) if(iVolume(symbolname,0,0)>1) barstatus=false; 


      
      //if (mafilter1 || mafilter1rev) 
      double ema1=iMA(NULL,matime1,maperiod1,0,mamethod1,PRICE_CLOSE,shift);
      //if (mafilter2 || mafilter2rev) 
      double ema2=iMA(symbolname,matime2,maperiod2,0,mamethod2,PRICE_CLOSE,shift);
      //if (mafilter3 || mafilter3rev)
      double ema3=iMA(symbolname,matime3,maperiod3,0,mamethod3,PRICE_CLOSE,shift);


if (strategy == 1)
{
if ((MACDAlways==false 
&& MACDmain1 < 0 && MACDmain > 0
)
||(MACDAlways 
&& MACDmain > 0)){
if (reverse) SellCondition1 = true; else BuyCondition1 = true; 
TradeDirection = "UP";
CrossTime      = iTime(symbolname,TimeFrame,0);
}

if (MACDmain > 0)
if (reverse) CloseBuyCondition1 = true; else CloseSellCondition1 = true; 

if ((MACDAlways==false 
&& MACDmain1 > 0 && MACDmain < 0)
||(MACDAlways  
&& MACDmain < 0))
{
if (reverse) BuyCondition1 = true; else SellCondition1 = true; 
TradeDirection = "DOWN";
CrossTime      = iTime(symbolname,TimeFrame,0);
}

if (MACDmain < 0)
if (reverse) CloseSellCondition1 = true; else CloseBuyCondition1 = true; 
}

///////////////////////////////////////////////////////////////
if (strategy == 2)
{
if ((MACDAlways==false 
&& MACDmain1 < MACDsignal1
&& MACDmain >= MACDsignal
)
||(MACDAlways 
&& MACDmain > MACDsignal)){
if (reverse) SellCondition1 = true; else BuyCondition1 = true; 

TradeDirection = "UP";
CrossTime      = iTime(symbolname,TimeFrame,0);
}

if (MACDmain > MACDsignal)
if (reverse) CloseBuyCondition1 = true; else CloseSellCondition1 = true; 

if ((MACDAlways==false 
&& MACDmain1 > MACDsignal1
&& MACDmain <= MACDsignal)
||(MACDAlways  
&& MACDmain < MACDsignal))
{
if (reverse) BuyCondition1 = true; else SellCondition1 = true; 
TradeDirection = "DOWN";
CrossTime      = iTime(symbolname,TimeFrame,0);
}

if (MACDmain < MACDsignal)
if (reverse) CloseSellCondition1 = true; else CloseBuyCondition1 = true; 

}

////////////////////////////////////////////////////////////
if (BuyCondition1 
&& TradeTime() && DaytoTrade() 
&& (SingleWeekDay==false || (DayOfWeek()==dayofweek))
      && (mafilter1==false || (mafilter1 && Ask>ema1))
      && (mafilter2==false || (mafilter2 && Ask>ema2))
      && (mafilter3==false || (mafilter3 && Ask>ema3))
       && (mafilter1rev==false || (mafilter1rev && Ask<ema1))
      && (mafilter2rev==false || (mafilter2rev && Ask<ema2))
      && (mafilter3rev==false || (mafilter3rev && Ask<ema3))
)                            
OpenBuy=true;



                        
if (OppositeClose && CloseSellCondition1) 
CloseSell=true;                              


if (SellCondition1
  && TradeTime() && DaytoTrade()
&& (SingleWeekDay==false || (DayOfWeek()==dayofweek))
   && (mafilter1==false || (mafilter1 && Ask<ema1))
      && (mafilter2==false || (mafilter2 && Ask<ema2))
      && (mafilter3==false || (mafilter3 && Ask<ema3))
       && (mafilter1rev==false || (mafilter1rev && Ask>ema1))
      && (mafilter2rev==false || (mafilter2rev && Ask>ema2))
      && (mafilter3rev==false || (mafilter3rev && Ask>ema3))

)
OpenSell=true;    
 
                       


if (OppositeClose && CloseBuyCondition1) 
CloseBuy=true;

                             


//----------------------- ALERT ON CROSS
   if(EnableAlert==true 
   //&& ConfirmedOnEntry==true
   )
   {
      if(TradeDirection=="UP" && LastAlert!="UP")
      {
         subCrossAlert("UP");
         LastAlert = "UP";
      }            
      if(TradeDirection=="DOWN" && LastAlert!="DOWN")
      {
         subCrossAlert("DOWN");
         LastAlert ="DOWN"; 
      }
   }    

//-------------------------------------------------
// Section 3D: Close Conditions
   
   while(true)                                 
     {
      if (OType==0 && CloseBuy==true)              
        {                                     
         close (OP_BUY);         // Close Buy
         return;                                
        }

      if (OType==1 && CloseSell==true)               
        {                                            
         close (OP_SELL);     // Close Sell
         return;                               
        }
      break;                                   
     }
     
     
  if (BreakEvenStart > 0) BreakEvenOrder (BreakEvenStart, BreakEven);  
  if(TrailingStop>0 && TrailingStart==0) TrailOrder1();
  if(TrailingStop>0 && TrailingStart > 0) TrailOrder2(TrailingStart, TrailingStop); 
     
//--------------------------------------------------
// Section 3E: Order Placement 
    
while(true) {
if (OrdersTotalMagicOpen()==0 && OpenBuy==true && !SellOnly


){  
//if (Time0 != Time[0] && CheckTodaysOrders() <= MaxDayOrders){
ticket=0;number=0;                                            
if(StopLoss>0){SL=Bid - StopLoss*vPoint;}else{SL=0;} if(TakeProfit>0){TP=Bid+TakeProfit*vPoint;}else{TP=0;}

if (!ECN) {      
while(ticket<=0 && number<100){ 
RefreshRates();
ticket = OrderSend(Symbol(),OP_BUY,Lots(), Ask,vSlippage,SL,TP,BuyComment, MagicNumber, 0, Green);       
         return (ticket);                                          
        }}
if (ECN) {
 while(ticket<=0 && number<100){ 
RefreshRates();
ticket = OrderSend(Symbol(),OP_BUY,Lots(), Ask,vSlippage,0,0,BuyComment, MagicNumber, 0, Green);       
//if(ECN)ecnmodify(stoploss,takeprofit);


//return (ticket);  
if(ticket>0) 
{
OrderSelect(ticket,SELECT_BY_TICKET);
OrderModify(OrderTicket(),OrderOpenPrice(),SL, TP,0,Green);
}      
                                  
        }}}
             
      if (OrdersTotalMagicOpen()==0 && OpenSell==true && !BuyOnly
     
      
      )                   
        {
       // if (Time0 != Time[0] && CheckTodaysOrders() <= MaxDayOrders){                                                   
        if(StopLoss>0){SL=Ask + StopLoss*vPoint;}else{SL=0;} if(TakeProfit>0){TP=Ask-TakeProfit*vPoint;}else{TP=0;}
       ticket=0;number=0; 
if (!ECN) {
while(ticket<=0 && number<100){ 
RefreshRates();
ticket= OrderSend(Symbol(),OP_SELL, Lots(), Bid,vSlippage,SL,TP, SellComment, MagicNumber, 0, Red);       
         return (ticket);
         }}
          if (ECN) {
 while(ticket<=0 && number<100){ 
RefreshRates();
ticket= OrderSend(Symbol(),OP_SELL, Lots(), Bid,vSlippage,0,0, SellComment, MagicNumber, 0, Red);        
 
if(ticket>0) 
{
OrderSelect(ticket,SELECT_BY_TICKET);
OrderModify(OrderTicket(),OrderOpenPrice(),SL, TP,0,Green);
}       
           
         }}
         }
      break;                                                
     }
     
     
     
     
     
//---------------------------------------------------------------
   return;                        // End of start()
  }


// Section 4A: Close Function 

void close(int type){

if(OrdersTotal()>0){
for(cnt=OrdersTotal()-1;cnt>=0;cnt--){

OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES); 
if(type==OP_BUY && OrderType()==OP_BUY){
if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) { 
RefreshRates(); OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),vSlippage);
}} 

if(type==OP_SELL && OrderType()==OP_SELL){
if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) { 
RefreshRates(); OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),vSlippage); 
}}
}}
}

// Section 4B: OrdersTotal Function

int OrdersTotalMagicOpen() {
int l_count_0 = 0;
for (int l_pos_4 = OrdersTotal() - 1; l_pos_4 >= 0; l_pos_4--) {
OrderSelect(l_pos_4, SELECT_BY_POS, MODE_TRADES);
if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
if (OrderType() == OP_SELL || OrderType() == OP_BUY) l_count_0++;
   }
return (l_count_0);
   }
   
   
void BreakEvenOrder(double BreakEvenStart,double BreakEven){
int ticket = 0; 
double sl = OrderStopLoss(); // Stop Loss
double bid = NormalizeDouble(Bid,Digits); 
double ask = NormalizeDouble(Ask,Digits); 
RefreshRates();
if(OrdersTotal()>0){
for(cnt=OrdersTotal();cnt>=0;cnt--){
OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber){

if(OrderType()==OP_BUY){
if(NormalizeDouble((Bid-OrderOpenPrice()),Digits)>=NormalizeDouble(BreakEvenStart*vPoint,Digits)){
if((NormalizeDouble((OrderStopLoss()-OrderOpenPrice()),Digits)<NormalizeDouble(BreakEven*vPoint,Digits)) || OrderStopLoss()==0){
sl = NormalizeDouble(OrderOpenPrice()+ BreakEven*vPoint,Digits);
ticket = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Blue);
if (ticket > 0){
Print ("BreakEven Activated: ", OrderSymbol(), ": SL", sl, ": Bid", Bid);
return(0);
}}}}
if (OrderType()==OP_SELL){           
if(NormalizeDouble((OrderOpenPrice()-Ask),Digits)>=NormalizeDouble(BreakEvenStart*vPoint,Digits)){
if((NormalizeDouble((OrderOpenPrice()-OrderStopLoss()),Digits)<NormalizeDouble(BreakEvenStart*vPoint,Digits)) || OrderStopLoss()==0){
sl = NormalizeDouble(OrderOpenPrice()-BreakEvenStart*vPoint,Digits);
ticket = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Red);
if (ticket > 0){
Print ("BreakEvent Activated: ", OrderSymbol(), ": SL", sl, ": Ask", Ask);
return(0);
}}}}
}}}}



void TrailOrder1()
{
int ticket = 0; 
double sl = OrderStopLoss(); // Stop Loss
RefreshRates();
if(OrdersTotal()>0){
for(cnt=OrdersTotal();cnt>=0;cnt--){
OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
if (OrderSymbol()==Symbol() 
&& OrderMagicNumber()==MagicNumber){

if(OrderType()==OP_BUY)
{
if(Bid> NormalizeDouble (OrderOpenPrice()+ TrailingStop * vPoint, Digits))
{
if (Bid > NormalizeDouble (sl + (TrailingStop+TrailingStep)*vPoint, Digits)) 
// must first overcome spread
{
sl = NormalizeDouble (Bid - TrailingStop * vPoint, Digits); 
ticket = OrderModify(OrderTicket(),OrderOpenPrice(),sl,
OrderTakeProfit(),0,Green);
if (ticket > 0)
{
Print ("TrailingStop#1 Activated: ", OrderSymbol(), ": SL", sl, ": Bid", Bid);
}}}}

if(OrderType()==OP_SELL)
{
if (Ask <= NormalizeDouble (OrderOpenPrice() - TrailingStop*vPoint, Digits) )
{
if (Ask < NormalizeDouble (sl - (TrailingStop + TrailingStep) * vPoint, Digits)) 
// must first overcome spread
{
sl = NormalizeDouble (Ask + TrailingStop * vPoint, Digits); 
ticket = OrderModify(OrderTicket(),OrderOpenPrice(), sl,
OrderTakeProfit(),0, Red);

if (ticket > 0)
{
Print ("TrailingStop#1 Activated: ", OrderSymbol(), ": SL ", sl, ": Ask ", Ask); 
}}}}

}}}}


void TrailOrder2(double Trailingstart,double Trailingstop){
int ticket = 0; 
double sl = NormalizeDouble(OrderStopLoss(), Digits); // Stop Loss


RefreshRates();
if(OrdersTotal()>0){
for(cnt=OrdersTotal();cnt>=0;cnt--){
OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() 
&& OrderMagicNumber()==MagicNumber){

if(OrderType()==OP_BUY){
if(Ask> NormalizeDouble(OrderOpenPrice()+TrailingStart* vPoint,Digits)
&& sl < NormalizeDouble(Bid-(TrailingStop+TrailingStep)*vPoint,Digits)){
sl = NormalizeDouble(Bid-TrailingStop*vPoint,Digits);
ticket = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Blue);
if (ticket > 0){
Print ("TrailingStop#2 Activated: ", OrderSymbol(), ": SL", sl, ": Bid", Bid);
return(0);
}}}

if (OrderType()==OP_SELL) {
if (Bid <  NormalizeDouble(OrderOpenPrice()-TrailingStart*vPoint,Digits)
&& (sl >(NormalizeDouble(Ask+(TrailingStop+TrailingStep)*vPoint,Digits)))
|| (OrderStopLoss()==0)){
sl = NormalizeDouble(Ask+TrailingStop*vPoint,Digits);                  
ticket = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Red);
if (ticket > 0){
Print ("Trailing#2 Activated: ", OrderSymbol(), ": SL ",sl, ": Ask ", Ask); 
return(0);
}}}
}}}}


    

double Lots()
{
double minlot = MarketInfo(Symbol(), MODE_MINLOT);
double maxlot = MarketInfo(Symbol(), MODE_MAXLOT);
double leverage = AccountLeverage();
double lotsize = MarketInfo(Symbol(), MODE_LOTSIZE);
double stoplevel = MarketInfo(Symbol(), MODE_STOPLEVEL);

double MaximalLots = 50.0;

if(MM)
{

double vLots = NormalizeDouble(AccountFreeMargin() * Risk/100 / 1000.0, LotDigits);
if(vLots < minlot) vLots = minlot;
if (vLots > MaximalLots) vLots = MaximalLots;
if (AccountFreeMargin() < Ask * vLots * lotsize / leverage) {
Print("We have no money. Lots = ", vLots, " , Free Margin = ", AccountFreeMargin());
Comment("We have no money. Lots = ", vLots, " , Free Margin = ", AccountFreeMargin());
}}
else vLots=NormalizeDouble(Lots,Digits);
return(vLots);
}


int GMTOffset() {
   int lia_0[4];
   int lia_4[43];
   string ls_unused_16;
   GetSystemTime(lia_0);
   int li_36 = lia_0[0] & 65535;
   int li_40 = lia_0[0] >> 16;
   int li_44 = lia_0[1] >> 16;
   int li_48 = lia_0[2] & 65535;
   int li_52 = lia_0[2] >> 16;
   int li_56 = lia_0[3] & 65535;
   string ls_8 = FormatDateTime(li_36, li_40, li_44, li_48, li_52, li_56);
   double ld_28 = TimeCurrent() - StrToTime(ls_8);
   gs_548 = "\n   Greenwich Mean Time : " + TimeToStr(StrToTime(ls_8), TIME_DATE|TIME_MINUTES|TIME_SECONDS) 
      + "\n   Broker Time : " + TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES|TIME_SECONDS) 
   + "\n   Local Time : " + TimeToStr(TimeLocal(), TIME_DATE|TIME_MINUTES|TIME_SECONDS);
   return (MathRound(ld_28 / 3600.0));
}

string FormatDateTime(int ai_0, int ai_4, int ai_8, int ai_12, int ai_16, int ai_20) {
   string ls_24 = ai_4 + 100;
   ls_24 = StringSubstr(ls_24, 1);
   string ls_32 = ai_8 + 100;
   ls_32 = StringSubstr(ls_32, 1);
   string ls_40 = ai_12 + 100;
   ls_40 = StringSubstr(ls_40, 1);
   string ls_48 = ai_16 + 100;
   ls_48 = StringSubstr(ls_48, 1);
   string ls_56 = ai_20 + 100;
   ls_56 = StringSubstr(ls_56, 1);
   return (StringConcatenate(ai_0, ".", ls_24, ".", ls_32, " ", ls_40, ":", ls_48, ":", ls_56));
}


int TradeTime()
{
if (!IsTesting() && AutoGMTOffset == TRUE) gmtoffset = GMTOffset();
   else gmtoffset = ManualGMTOffset;

int TradingTime=0;
int CurrentHour=Hour(); // Server time in hours
double CurrentMinute =Minute(); // Server time in minutes
double CurrentTime=CurrentHour + CurrentMinute/100; // Current time
double CurrentTime1 = CurrentTime + gmtoffset;  

if (CurrentTime1==0) CurrentTime=00;  
if (CurrentTime1<0) CurrentTime1 = CurrentTime1 + 24; 
if (CurrentTime1 >= 24) CurrentTime1 = CurrentTime1 - 24; 

if (!DaytoTrade()) return(false);
if (UseTradingHours==true)
{
if (TradeAsianMarket==true)
{
if(StartTime1<EndTime1){
if(CurrentTime1>=StartTime1 && CurrentTime1<=EndTime1)
TradingTime=1;}

if(StartTime1>EndTime1){
if(CurrentTime1>=StartTime1 || CurrentTime1<=EndTime1)
TradingTime=1;}
}

if (TradeEuropeanMarket==true)
{
if(StartTime2<EndTime2){
if(CurrentTime1>=StartTime2 && CurrentTime1<=EndTime2)
TradingTime=1;}

if(StartTime2>EndTime2){
if(CurrentTime1>=StartTime2 || CurrentTime1<=EndTime2)
TradingTime=1;}
}

if (TradeNewYorkMarket==true)
{
if(StartTime3<EndTime3){
if(CurrentTime1>=StartTime3 && CurrentTime1<=EndTime3)
TradingTime=1;}

if(StartTime3>EndTime3){
if(CurrentTime1>=StartTime3 || CurrentTime1<=EndTime3)
TradingTime=1;}
}
}

else
TradingTime=1;

return(TradingTime);
}

bool DaytoTrade(){
bool daytotrade = false;

if(DayOfWeek() == 0 && Sunday) daytotrade = true;
if(DayOfWeek() == 1 && Monday) daytotrade = true;
if(DayOfWeek() == 2 && Tuesday) daytotrade = true;
if(DayOfWeek() == 3 && Wednesday) daytotrade = true;
if(DayOfWeek() == 4 && Thursday) daytotrade = true;
if(DayOfWeek() == 5 && Friday) daytotrade = true;
if(DayOfWeek() == 5 && Day() < 8 && AvoidNFPFriday ) daytotrade = false;
if(DayOfWeek() == 4 && Day() < 8 && AvoidNFPThursdayBefore ) daytotrade = false;
if(Month() == 12 && Day() > XMAS_DayBeginBreak && AvoidChristmasHolidays ) daytotrade = false;
if(Month() == 1 && Day() < NewYears_DayEndBreak && AvoidNewYearsHolidays ) daytotrade = false;

return(daytotrade);}

//----------------------- ALERT ON BollingerBand Cross
//----------------------- SOURCE : FIREDAVE
void subCrossAlert(string type)
{
   string AlertComment;
   
   if(type=="UP")   AlertComment = "MACD UP!";
   if(type=="DOWN") AlertComment = "MACD DN!";
   
   Alert(AlertComment);
   PlaySound(SoundFilename);
}

int CheckTodaysOrders(){

int TodaysOrders = 0;

for(int i = OrdersTotal()-1; i >=0; i--){

OrderSelect(i, SELECT_BY_POS,MODE_TRADES);

if(TimeDayOfYear(OrderOpenTime()) == TimeDayOfYear(TimeCurrent()) && OrderSymbol() == Symbol()
&& OrderMagicNumber()==MagicNumber
){

TodaysOrders += 1;

}

}

for(i = OrdersHistoryTotal()-1; i >=0; i--){

OrderSelect(i, SELECT_BY_POS,MODE_HISTORY);

if(TimeDayOfYear(OrderOpenTime()) == TimeDayOfYear(TimeCurrent()) && OrderSymbol() == Symbol()
&& OrderMagicNumber()==MagicNumber
){

TodaysOrders += 1;

}

}

return(TodaysOrders);

}

